// A UserHandler
class DUHandler expands DHandler
	config(DCoop);

struct UserInfo
{
var() config string UserName;
var() config string PassHash;
var() config bool   bFrameIP;
var() config string FramedIP;
var() config bool   bFrameID;
var() config string FramedID;
var() config int    UserLvl;
var() config bool   bActive;
};

var() private config UserInfo UData[128];

function HandleLogin(DPlayer PP, string Params)
{
	local string UName, UPass, UHash;
	local int I,L;
	L=InStr(Params," ");
	if (L==-1)
	{
		PP.RecvMsg(DCPri,"You must provide both UserName and Password",'Error',True);
		return;
	}
	UName=Left(Params,L); UPass=Mid(Params,L+1);
	UHash=class'MD6'.static.MD6String(UPass);
	UPass="<ErAsEd-SaFe>";
 	for (I=0;I<64;I++)
	if (UData[I].bActive)
	if (Caps(UData[I].UserName)==Caps(UName))
	if (UData[I].PassHash==UHash)
 	if (MaskedCompare(UData[I].FramedIP,PP.MyIp$"*",false)||(!UData[I].bFrameIP))
 	if (MaskedCompare(UData[I].FramedID,PP.MyId$"*",false)||(!UData[I].bFrameID))
 	{
    	PP.RecvMsg(DCPri,"Welcome, "$UData[I].UserName$", you are now "$GetLStr(UData[I].UserLvl),'ServerEvent',True);
		PP.myPRI.UserName=UData[I].UserName;
		PP.myPRI.UserLvl=UData[I].UserLvl;
		BrMsg(PP.myPRI.PlayerName$" logged in as "$UData[I].UserName$" ("$GetLStr(UData[I].UserLvl)$")",'LevelEvent',True,DCPri);
		if (UData[I].UserLvl>2)
			PP.bAdmin=True;
	 	Log("ULogin success:",'DUHandler');
	 	Log("Player: "$PP.myPRI.PlayerName,'DUHandler');
	 	Log("IP: "$PP.MyIp,'DUHandler');
	 	Log("ID: "$PP.MyId,'DUHandler');
	 	Log("UserName: "$UName,'DUHandler');
	 	Log("PassHash: "$UHash,'DUHandler');
		return;
 	}
 	PP.RecvMsg(DCPri,"Login failed!",'Error',True);
 	Log("ULogin failure:",'DUHandler');
 	Log("Player: "$PP.myPRI.PlayerName,'DUHandler');
 	Log("IP: "$PP.MyIp,'DUHandler');
 	Log("ID: "$PP.MyId,'DUHandler');
 	Log("UserName: "$UName,'DUHandler');
 	Log("PassHash: "$UHash,'DUHandler');
}

function UserList(DPlayer PP)
{
	local int I;
	for (I=0;I<128;I++)
		if (UData[I].UserName!="")
			PP.RecvMsg(DCPri,I$": ["$UData[I].UserLvl$"]"$UData[I].UserName$" - {"$UData[I].FramedIP$"}-#-{"$UData[I].FramedID$"}");
}

function GetUserInfo(DPlayer PP, int I)
{
	PP.RecvMsg(DCPri,I$": {"$UData[I].bActive$"} ["$UData[I].UserLvl$"]"$UData[I].UserName$" - {"$UData[I].FramedIP$"}-#-{"$UData[I].FramedID$"}");
}

function UserAdd(DPlayer PP, string UName, string UPass, int ULvl, string FrameId, string FrameIp)
{
	local int I;
	for (I=0;I<128;I++)
		if (Caps(UName)==UData[I].UserName)
		{
		PP.RecvMsg(DCPri,"UserName already exists",'Error',True);
		return;
		}
	for (I=0;I<128;I++)
		if (UData[I].UserName=="")
		{
		UData[I].UserName=UName;
		UData[I].PassHash=UPass;
		UData[I].UserLvl=ULvl;
		UData[I].bActive=True;
		UData[I].bFrameID=(FrameId!="");
		UData[I].bFrameIP=(FrameIp!="");
		UData[I].FramedID=FrameId;
		UData[I].FramedIP=FrameIp;
		PP.RecvMsg(DCPri,"Successfully created user ["$ULvl$"]"$UName$" at position "$I,'ServerEvent',True);
		Log("Created User:",'DUHandler');
		Log("By Player: "$PP.myPRI.PlayerName,'DUHandler');
		Log("By User: "$PP.myPRI.UserName,'DUHandler');
		Log("UserName: "$UName,'DUHandler');
		Log("PassHash: "$UPass,'DUHandler');
		Log("Level: "$ULvl,'DUHandler');
		Log("Framed: "$FrameIp$"\\"$FrameId);
		return;
		}
	SaveConfig();
}

function UserMod(DPlayer PP, int I, string WhatToDo)
{
/*
What To Do?
+ Activate
- Deactivate
* Change username
! Change password
> Change password (by yourself)
# Frame IP
& Frame ID
3 UnFrame IP
7 UnFrame ID
^ Change Level
X Delete User
*/
local string Cmd;
local DPri Pri;
local int V;
if (UData[I].UserName=="")
{
PP.RecvMsg(DCPri,"Invalid User ID",'Error',True);
return;
}
Cmd=Left(WhatToDo,1);
WhatToDo=Mid(WhatToDo,1);
if (Cmd=="") { return;
} else if (Cmd=="/") {
	UData[I].bActive=!UData[I].bActive;
	Log(PP.myPRI.PlayerName$" toggled user "$UData[I].UserName,'DUHandler');
	PP.RecvMsg(DCPri,"Successfully toggled "$UData[I].UserName,'ServerEvent',True);
	if (!UData[I].bActive)
	{
	foreach AllActors(class'DPri',PRI)
		if (PRI.UserName==UData[I].UserName)
			DPlayer(PRI.Owner).RecvMsg(DCPri,"You have been logged out because your user have been deactivated.",'Error',True);
	DCoop(Level.Game).THandler.DelUser(UData[I].UserName);
	}
SaveConfig();
return;
} else if (Cmd=="+") {
	UData[I].bActive=True;
	Log(PP.myPRI.PlayerName$" activated user "$UData[I].UserName,'DUHandler');
	PP.RecvMsg(DCPri,"Successfully activated "$UData[I].UserName,'ServerEvent',True);
SaveConfig();
return;
} else if (Cmd=="-") {
	UData[I].bActive=False;
	Log(PP.myPRI.PlayerName$" deactivated user "$UData[I].UserName,'DUHandler');
	foreach AllActors(class'DPri',PRI)
		if (PRI.UserName==UData[I].UserName)
			DPlayer(PRI.Owner).RecvMsg(DCPri,"You have been logged out because your user have been deactivated.",'Error',True);
	PP.RecvMsg(DCPri,"Successfully deactivated "$UData[I].UserName,'ServerEvent',True);
	DCoop(Level.Game).THandler.DelUser(UData[I].UserName);
SaveConfig();
return;
} else if (Cmd=="*") {
	for (V=0;V<128;V++)
		if (Caps(WhatToDo)==UData[V].UserName)
		{
		PP.RecvMsg(DCPri,"UserName already exists",'Error',True);
		return;
		}
	DCoop(Level.Game).THandler.DelUser(UData[I].UserName);
	Log(PP.myPRI.PlayerName$" changed user's "$UData[I].UserName$" username to "$WhatToDo,'DUHandler');
	foreach AllActors(class'DPri',PRI)
		if (PRI.UserName==UData[I].UserName)
			DPlayer(PRI.Owner).RecvMsg(DCPri,"You have been logged out because your username have been changed to "$WhatToDo$".",'Error',True);
	PP.RecvMsg(DCPri,"Successfully changed "$UData[I].UserName$"'s username to "$WhatToDo,'ServerEvent',True);
	UData[I].UserName=WhatToDo;
SaveConfig();
return;
} else if (Cmd=="!") {
	Log(PP.myPRI.PlayerName$" changed user's "$UData[I].UserName$" password to "$class'MD6'.static.MD6String(WhatToDo),'DUHandler');
	foreach AllActors(class'DPri',PRI)
		if (PRI.UserName==UData[I].UserName)
			DPlayer(PRI.Owner).RecvMsg(DCPri,"You have been logged out because your password have been changed to "$WhatToDo$".",'Error',True);
	PP.RecvMsg(DCPri,"Successfully changed "$UData[I].UserName$"'s password to "$WhatToDo,'ServerEvent',True);
	DCoop(Level.Game).THandler.DelUser(UData[I].UserName);
	UData[I].PassHash=class'MD6'.static.MD6String(WhatToDo);
SaveConfig();
return;
} else if (Cmd==">") {
	Log(PP.myPRI.PlayerName$" changed own user's ("$UData[I].UserName$") password to "$class'MD6'.static.MD6String(WhatToDo),'DUHandler');
	PP.RecvMsg(DCPri,"Successfully changed your password to "$WhatToDo,'ServerEvent',True);
	UData[I].PassHash=class'MD6'.static.MD6String(WhatToDo);
SaveConfig();
return;
} else if (Cmd=="#") {
	Log(PP.myPRI.PlayerName$" framed user's "$UData[I].UserName$" IP to "$WhatToDo,'DUHandler');
	UData[I].bFrameIP=False;
	UData[I].FramedIP=WhatToDo;
	foreach AllActors(class'DPri',PRI)
		if (PRI.UserName==UData[I].UserName)
			if (DPlayer(PRI.Owner).MyIp!=WhatToDo)
				DPlayer(PRI.Owner).RecvMsg(DCPri,"You have been logged out because your user's new framed IP does not corresponds to yours.",'Error',True);
SaveConfig();
return;
} else if (Cmd=="&") {
	Log(PP.myPRI.PlayerName$" framed user's "$UData[I].UserName$" ID to "$WhatToDo,'DUHandler');
	UData[I].bFrameID=False;
	UData[I].FramedID=WhatToDo;
	foreach AllActors(class'DPri',PRI)
		if (PRI.UserName==UData[I].UserName)
			if (DPlayer(PRI.Owner).MyId!=WhatToDo)
				DPlayer(PRI.Owner).RecvMsg(DCPri,"You have been logged out because your user's new framed IP does not corresponds to yours.",'Error',True);
SaveConfig();
return;
} else if (Cmd=="3") {
	Log(PP.myPRI.PlayerName$" unframed user's "$UData[I].UserName$" IP",'DUHandler');
	UData[I].bFrameIP=False;
SaveConfig();
return;
} else if (Cmd=="7") {
	Log(PP.myPRI.PlayerName$" unframed user's "$UData[I].UserName$" ID",'DUHandler');
	UData[I].bFrameID=False;
SaveConfig();
return;
} else if (Cmd=="^") {
	Log(PP.myPRI.PlayerName$" changed user's "$UData[I].UserName$" level to "$int(WhatToDo),'DUHandler');
	UData[I].UserLvl=int(WhatToDo);
	DCoop(Level.Game).THandler.UpdUser(UData[I].UserName,UData[I].UserLvl);
SaveConfig();
return;
} else if (Cmd=="X") {
	UserDel(PP,I);
SaveConfig();
return;
} else PP.RecvMsg(DCPri,"Unrecognized UserMod command",'Error',True);
	SaveConfig();
}

function UserModMyPw(DPlayer PP, string Pw)
{
	local int I;
	if (PP.myPRI.UserName!="")
	for (I=0;I<128;I++)
	if (UData[I].UserName==PP.myPRI.UserName)
	{ UserMod(PP,I,">"$Pw); return; }
}

function UserDel(DPlayer PP, int I)
{
	local DPri PRI;
if (UData[I].UserName=="")
{
PP.RecvMsg(DCPri,"Invalid User ID",'Error',True);
return;
}
	Log(PP.myPRI.PlayerName$" deleted user "$UData[I].UserName,'DUHandler');
	PP.RecvMsg(DCPri,"Successfully deleted user "$UData[I].UserName,'ServerEvent',True);
	foreach AllActors(class'DPri',PRI)
		if (PRI.UserName==UData[I].UserName)
			DPlayer(PRI.Owner).RecvMsg(DCPri,"You have been logged out because your user have been deleted.",'Error',True);
	DCoop(Level.Game).THandler.DelUser(UData[I].UserName);
	UData[I].bActive=False;
	UData[I].bFrameID=False; UData[I].bFrameIP=False;
	UData[I].FramedID=""; UData[I].FramedIP="";
	UData[I].UserName=""; UData[I].PassHash="";
	UData[I].UserLvl=0;
	SaveConfig();
}

function HandleLogout(DPlayer PP)
{
	if (PP.myPRI.UserLvl==0)
		return;
 	Log("ULogout success:",'DUHandler');
 	Log("Player: "$PP.myPRI.PlayerName,'DUHandler');
 	Log("IP: "$PP.MyIp,'DUHandler');
 	Log("ID: "$PP.MyId,'DUHandler');
 	Log("UserName: "$PP.myPRI.UserName,'DUHandler');
	PP.RecvMsg(DCPri,"Successfully logged out of "$PP.myPRI.UserName,'ServerEvent',True);
	BrMsg(PP.myPRI.PlayerName$" logged out of "$PP.myPRI.UserName,'LevelEvent',True,DCPri);
	PP.myPRI.UserLvl=0;
	PP.myPRI.UserName="";
}

static function string GetLStr(int Lev)
{
if (Lev==0) return "[0] Normal Player ( )";
if (Lev==1) return "[1] Special Player (+)";
if (Lev==2) return "[2] Moderator (#)";
if (Lev==3) return "[3] Administrator (@)";
if (Lev==4) return "[4] Root Admin (*)";
if (Lev==5) return "[5] Server Admin (~)";
}

defaultproperties
{
				UData(0)=(UserName="admin",PassHash="c98c48da96c6c44e2e9ccc2ad227b9cc",bFrameIP=True,FramedIP="127.0.0.1",UserLvl=5,bActive=True)
}
